# Blender add-on. Import in User Settings/Addons.

import bpy
from math import pi

def render_pass(init_z_rot_radians, z_rot_frac_radians, length_scale, zoom):
	global ttd_object
	
	ttd_object.scale = [zoom, zoom * length_scale, zoom]
	ttd_object.rotation_euler.z = init_z_rot_radians

	i = 0
	while  i < 2 * pi / z_rot_frac_radians:
		bpy.ops.render.render()
		# TODO: add livery name? Separate models are easier to handle.
		# Add path for company too (assume all models in certain directory)?
		bpy.data.images['Render Result'].save_render(bpy.path.abspath(bpy.context.scene.render.filepath) + bpy.path.display_name_from_filepath(bpy.data.filepath) + '-' + str(round(ttd_object.rotation_euler.z * 180 / pi)) + '.png')
	
		ttd_object.rotation_euler.z += z_rot_frac_radians
		i += 1
			
	ttd_object.scale = [1.0, 1.0, 1.0]
	ttd_object.rotation_euler.z = 0
	
bpy.context.scene.render.image_settings.file_format = 'PNG'
ttd_object = bpy.data.objects.get("ttd_model")

if ttd_object == None:
	'Rendering error: ttd_model does not exist'
	'(file: ' + bpy.path.display_name_from_filepath(bpy.data.filepath) + ')'

if ttd_object.type != 'MESH':
	'Rendering error: ttd_model is not a mesh object'
	'(file: ' + bpy.path.display_name_from_filepath(bpy.data.filepath) + ')'

# Standard horizontal/vertical views
render_pass(0, pi / 2, 1.0, 1.0)

# Standard diagonal views
render_pass(pi / 4, pi / 2, 0.75 * 32.0 / 34.0, 1.0)
	
# Extra CETS angles, sorted from most horizontal to most vertical
# Angle values found by binary search, scaling by comparison of side lengths
# Angles kept positive for better ordering
render_pass(pi * 8.38125 / 180, pi, 57.0 / 63.0, 1.0)
render_pass(pi * (1 - 8.38125 / 180), pi, 57.0 / 63.0, 1.0)
render_pass(pi * 30.9375 / 180, pi, 40.0 / 55.0, 1.0)
render_pass(pi * (1 - 30.9375 / 180), pi, 40.0 / 55.0, 1.0)
render_pass(pi * 56.25 / 180, pi, 25.0 / 35.0, 1.0)
render_pass(pi * (1 - 56.25 / 180), pi, 25.0 / 35.0, 1.0)
render_pass(pi * 80.390625 / 180, pi, 0.8425, 1.0)
render_pass(pi * (1 - 80.390625 / 180), pi, 0.8425, 1.0)
